""" beispiel_ls3_02 - Demo-Beispiel Funktionen
    Name, Organisaion:          Markus Breuer, BK-GuT
    Erstellt, Letzte Änderung:  24.11.2020, 18.06.2022
    """


# Definition f_1 - f_1 zählt von 0 bis n
def f_1(n):
    """Funktion f_1 - Funktion, die bis n zählt und nichts zurückgibt"""
    i = 0
    while i <= n:
        print(i)
        i = i + 1
    print("")


# Aufrufe von f_1
f_1(5)
z = int(input("Wie weit soll ich zählen? "))
f_1(z)


# Definition f_2 - f_2 berechnet das Volumen einer Quaders
def f_2(laenge=5, breite=5, hoehe=5):
    """Funktion f_2 - berechnet Volumen eines Quaders und gibt dieses zurück"""
    volumen = laenge * breite * hoehe
    return volumen


# Aufrufe von f_2
vol = f_2(10, 10, 5)  # Aufruf mit allen Parametern
print("Volumen bei Aufruf von 'f_2( 10, 10, 5)':", vol)
vol = f_2()  # Aufruf ohne Parameter
print("Volumen bei Aufruf von 'f_2()':", vol)
vol = f_2(1, 1)  # Aufruf mit 2 von 3 Parametern
print("Volumen bei Aufruf von 'f_2( 1, 1)':", vol)
vol = f_2(hoehe=7)  # Aufruf mit benamten Parametern
print("Volumen bei Aufruf von 'f_2( h = 7)':", vol)
print("")


# Definition f_3 - f_1 zählt von 0 bis n und gibt dies als Liste zurück
def f_3(n):
    """Funktion f_3 - gibt eine Liste zurück"""
    liste_lokal = []
    i = 0
    while i <= n:
        liste_lokal.append(i)
        i = i + 1
    return liste_lokal


# Aufruf von f_3
liste_global = f_3(5)
print("Liste:", liste_global)
print("")


# Definition weiterer Funktionen, die ein ganzes Geflecht bilden
def f_4a():
    """Funktion f_4a"""
    print("f_4a - Start")
    print("f_4a - Ende")


def f_4b():
    """Funktion f_4a"""
    print("f_4b - Start")
    f_4c()
    print("f_4b - Ende")


def f_4c():
    """Funktion f_4a"""
    print("f_4c - Start")
    print("f_4c - Ende")


def f_4():
    """Funktion f_4a"""
    print("f_4 - Start")
    f_4a()
    f_4b()
    print("f_4 - Ende")


f_4()
print("")
